#ifndef __DXINPUT_H__
#define __DXINPUT_H__

#define DIRECTINPUT_VERSION 0x0700

// Header files
#include <dinput.h>
#include "macros.h"

#define DINPUT_BUFFERSIZE  16
 
// Class info
class DXInput
{
public:
	void DI_Term();
	bool DI_Init( HINSTANCE hInst, HWND hWnd );
	void ProcessKBInput();
	int  KeyPressed( int Key );
//	DXInput();
	~DXInput()
	{
		DI_Term();
	}

private:
    char					buffer[256];
	LPDIRECTINPUT7			m_lpDI;
	LPDIRECTINPUTDEVICE7	m_lpDIDeviceKB;
};

#endif